=== debian/changelog ===
rocthrust (5.7.1-2.1build1) noble; urgency=medium

  * No-change rebuild against librocprim-dev 5.7.1-2

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 23 Apr 2024 10:54:01 +0000

rocthrust (5.7.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Reintroduce fallback in invoke_result with upstream proposed
    and acked patch (Closes: #1064730)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 18:21:04 +0200

rocthrust (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable
  * d/rules: use rocprim arch conversion to ensure that the rocthrust tests
    behave the same on all RDNA 2 hardware

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 26 Mar 2024 11:40:24 -0600

rocthrust (5.7.1-2~exp1) experimental; urgency=medium

  * Enable gfx1100, gfx1101, and gfx1102 architectures in test binaries
  * Update Build-Depends for clang-17
  * Drop patchelf from Build-Depends
  * Add support for nocheck Build-Profile

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 01 Mar 2024 14:27:49 -0700

rocthrust (5.7.1-1) unstable; urgency=medium

  * New upstream version 5.7.1
  * Update upstream URLs
  * d/rules: use compressed DWARF5 debug symbols
  * d/rules: drop gfx1011 from librocthrust-tests build architectures.
    The HIP runtime will fall back to using gfx1010.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 17 Feb 2024 13:43:54 -0700

rocthrust (5.3.3-5) unstable; urgency=medium

  * Filter cf-protection hardening from device code.
    Fixes a FTBFS with dpkg >= 1.22

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Sep 2023 22:31:01 +0200
